#include "cdatacreate2d.h"

//lhsize 水平方向の画素数
//lvsize 垂直方向の画素数
CDataCreate2D::CDataCreate2D(int lhsize,int lvsize)
{
    /*****二次元配列の確保*/
    Rdata=NULL;
    hsize=lhsize;
    vsize=lvsize;

    Rdata = (unsigned char **)new unsigned char *[hsize];
    Gdata = (unsigned char **)new unsigned char *[hsize];
    Bdata = (unsigned char **)new unsigned char *[hsize];

       for(int k=0;k<hsize;k++){
        Rdata[k] = (unsigned char *)new unsigned char[vsize];
        Gdata[k] = (unsigned char *)new unsigned char[vsize];
        Bdata[k] = (unsigned char *)new unsigned char[vsize];
    }

     /*上記の場合は、以下のような配列アクセスが可能
     for(int loop_y=0; loop_y<vsize; loop_y++){
         for(int loop_x=0; loop_x<hsize; loop_x++){
             r = qRed(lImage->pixel(loop_x, loop_y));
             g = qGreen(lImage->pixel(loop_x, loop_y));
             b = qBlue(lImage->pixel(loop_x, loop_y));

                     Rdata[loop_x][loop_y] =(unsigned char)r;
                     Gdata[loop_x][loop_y] =(unsigned char)g;
                     Bdata[loop_x][loop_y] =(unsigned char)b;
         }
     }
     */
}


CDataCreate2D::~CDataCreate2D()
{
     /*****二次元配列の破棄*/

    if(Rdata!=NULL){
        for(int k=0;k<hsize;k++){
            delete Rdata[k];
            delete Gdata[k];
            delete Bdata[k];
        }
        delete Rdata;
        delete Gdata;
        delete Bdata;
    }
}
void CDataCreate2D::mImage2data(QImage *linImage)
{

    int r,g,b;
    for(int loop_y=0; loop_y<vsize; loop_y++){
        for(int loop_x=0; loop_x<hsize; loop_x++){
            r = qRed(linImage->pixel(loop_x, loop_y));//ピクセルからRedデータを取り出す。
            g = qGreen(linImage->pixel(loop_x, loop_y));//ピクセルからGreenデータを取り出す。
            b = qBlue(linImage->pixel(loop_x, loop_y));//ピクセルからBlueデータを取り出す。

                    Rdata[loop_x][loop_y] =(unsigned char)r;
                    Gdata[loop_x][loop_y] =(unsigned char)g;
                    Bdata[loop_x][loop_y] =(unsigned char)b;
        }
    }

}
void CDataCreate2D::mImage2data(QImage linImage)
{

    int r,g,b;
    for(int loop_y=0; loop_y<vsize; loop_y++){
        for(int loop_x=0; loop_x<hsize; loop_x++){
            r = qRed(linImage.pixel(loop_x, loop_y));//ピクセルからRedデータを取り出す。
            g = qGreen(linImage.pixel(loop_x, loop_y));//ピクセルからGreenデータを取り出す。
            b = qBlue(linImage.pixel(loop_x, loop_y));//ピクセルからBlueデータを取り出す。

                    Rdata[loop_x][loop_y] =(unsigned char)r;
                    Gdata[loop_x][loop_y] =(unsigned char)g;
                    Bdata[loop_x][loop_y] =(unsigned char)b;
        }
    }

}
void CDataCreate2D::mdata2Image(QImage *linImage)
{
   // for(int loop_y=0; loop_y<vsize; loop_y++){
   //     for(int loop_x=0; loop_x<hsize; loop_x++){
   //         Rdata[loop_x][loop_y]  =(unsigned char)qRed(linImage->pixel(loop_x,loop_y));
   //         Gdata[loop_x][loop_y] =(unsigned char)0;
   //         Bdata[loop_x][loop_y] =(unsigned char)0;
    //     }

    //}
    laplacian(Rdata,(double)5.0,1,hsize,vsize);//test

    unsigned int r,g,b;
    int loop_y;
    int loop_x;
    for(loop_y=0; loop_y<vsize; loop_y++){
        for(loop_x=0; loop_x<hsize; loop_x++){
            r=Rdata[loop_x][loop_y];
            g=Gdata[loop_x][loop_y];
            b=Bdata[loop_x][loop_y];


            //Gray scale? or color
             if(linImage->allGray()){ //lImage->isGrayscale()
                  linImage->setPixel(loop_x, loop_y,qGray(r,g,b));//グレースケールの場合
              }
              else{
                  linImage->setPixel(loop_x, loop_y,qRgb(r,g,b));//カラー画像の場合
              }

         }

    }
}


void CDataCreate2D::laplacian(unsigned char **image_in,double amp, int type,int hsize,int vsize)
{
    int	i, j;
    int d;
    int c[3][9] = { 0, -1,  0, -1,  4, -1,  0, -1,  0,
                   -1, -1, -1, -1,  8, -1, -1, -1, -1,
                    1, -2,  1, -2,  4, -2,  1, -2,  1};

    int xsize,ysize;
    int offset;
    xsize = hsize;
    ysize = vsize;

    offset=128;

    unsigned char **data;
    data = (unsigned char **)new unsigned char *[xsize];

       for(int k=0;k<xsize;k++){
        data[k] = (unsigned char *)new unsigned char[ysize];
      }

       for (int n = 0; n< ysize; n++) {
           for (int m = 0; m < xsize; m++)
              data[m][n]=0;
        }

    type = type - 1;
    if (type < 0) type = 0;
    if (type > 2) type = 2;
    for (i = 1; i < ysize-1; i++) {
        for (j = 1; j < xsize-1; j++) {
            d = c[type][0] * image_in[j-1][i-1]
              + c[type][1] * image_in[j-1][i  ]
              + c[type][2] * image_in[j-1][i+1]
              + c[type][3] * image_in[j  ][i-1]
              + c[type][4] * image_in[j  ][i  ]
              + c[type][5] * image_in[j  ][i+1]
              + c[type][6] * image_in[j+1][i-1]
              + c[type][7] * image_in[j+1][i  ]
              + c[type][8] * image_in[j+1][i+1];
            d = (int)(d * amp) + offset;
            if (d <   0) d = 0;
            if (d > 255) d = 255;
            data[j][i] = (unsigned char)d;
        }
    }

    for (int n = 0; n < ysize; n++) {
        for (int m = 0; m < xsize; m++) {
            image_in[m][n]=data[m][n];
        }
    }

         for(int k=0;k<hsize;k++){
            delete data[k];
        }
        delete data;

}
