#include "mainwindow.h"
#include "ui_mainwindow.h"
//add include files
#include <QtGui>
#include "scene.h"//QGraphicsSceneクラスを基底オブジェクトとして生成する。
#include"view.h"//QGraphicsViewクラスを基底オブジェクトとして生成する。
///
#include<qfiledialog.h>//ファイルダイアログ用のincludeファイル設定

#include "cdatacreate2d.h"//画像を配列に入れるためのクラス。データをまとめておく。

MainWindow::MainWindow(QWidget *parent) :
    QMainWindow(parent),
    ui(new Ui::MainWindow)
{
    ui->setupUi(this);

     flag = 0;//画像読み込み用のフラグ
     gpmapI=new QGraphicsPixmapItem();//pixmap描画用のItemの確保

    createActions();//アクションの作成
    createMenus();//メニューの作成
    this->setGeometry(100,100,480,320);//this function set Window sizes.it is the QWidget class menber
    //add view,scene
    m_scene = new Scene;     //  シーン矩形部分
    m_scene->setSceneRect(-20,-30,480,320);//set view size ,マイナス座標も設定可m_scene->setSceneRect(-320,-240,640,480);
                                       //viewを大きめにとっておく。windowをドラッグしてviewの領域を超えると表示した画像がずれてくる
    m_view = new View;//viewの生成
    m_view->setScene(m_scene);//viewにsceneをセット
    setCentralWidget(m_view);//viewをwindowのセントラルウィジェットとして設定
}

MainWindow::~MainWindow()
{
    delete ui;
}
void MainWindow::createActions()
{
    newAct= new QAction(tr("&New"),this);//アクションを作成する。名前は「New」とする。
    connect(newAct,SIGNAL(triggered()),this,SLOT(newFile()));//アクションに対してシグナルとスロットを定義する。newFile()がスロット関数となる。
    saveAsAct = new QAction(tr("&saveAs"),this);//メニューバーにsaveAsを追加する。
    connect(saveAsAct,SIGNAL(triggered()),this,SLOT(saveAs()));
}
void MainWindow::createMenus()
{
    fileMenu = menuBar()->addMenu(tr("&File"));//メニューバーに「File」メニューを追加する
   //上記は右のコードでもよい。QMenu *fileMenu = menuBar()->addMenu(tr("&File"));
    fileMenu->addAction(newAct);//メニューにcreateActions関数で作成したアイテムを追加する。
    fileMenu->addAction(saveAsAct);//FileメニューにsaveAsメニューを登録する。
}
//newActに対するスロット関数
void MainWindow::newFile()
{
    //QMessageBox::information(0,"title","NewFile");
    QString fName = QFileDialog::getOpenFileName(this, tr("Open File"),"/home",tr("Images (*.png *.xpm *.jpg *.bmp)"));//ファイルダイアログを表示して、ファイル名を取得する。

     //以下でファイルからデータを読み込む
     if(!inImage.load(fName)){
            QMessageBox::warning(0,"No file",fName);//ファイルが読み込めなかった場合メッセージを表示する。
            return;//読み込めなかった場合はなにもせずに関数から抜け出す。
       }

     if(flag==1){
            delete m_dcrt2d;//一度配列用のデータクラスを確保していれば、廃棄する。
     }
     //////test
     m_dcrt2d=new CDataCreate2D((int)inImage.width(),(int)inImage.height());//add20120421処理用配列の確保のためのクラス作成
     m_dcrt2d->mImage2data(&inImage);
     m_dcrt2d->mdata2Image(&inImage);
     /////////

     pixmap_in.convertFromImage(inImage);//読み込んだイメージデータをピックスマップに変換する。
     gpmapI->setPixmap(pixmap_in);//GraphicsPixmapItemに上記のピックスマップをセットする。

     //以下は、flag=1の場合、すでに一度sceneにPixmapItem(ピックスマップに変換したイメージ)が登録されているので、新しいイメージを読み込んだ場合を考えて、すでにセットされているpixmapを取り除く
     if(flag==1){
         m_scene->removeItem(gpmapI);//一度ファイルを読み込んでいたらItemをsceneから取り除く

     }
     m_scene->addItem(gpmapI);//sceneにピックスマップを追加する。
     m_view->setScene(m_scene);//viewにsceneをセットする。
     flag=1;//flagを変更
    this->update();//再描画する。paintEventを呼び出す
}
void MainWindow::saveAs()
{

    QString fileName = QFileDialog::getSaveFileName(this, tr("Save File"),"/home/untitled.jpg",tr("Images (*.bmp *.xpm *.jpg)"));
    if(!fileName.isEmpty())
    {
        //save function
        // If format is 0, QImage will attempt to guess the format by looking at fileName's suffix.
        // The quality factor must be in the range 0 to 100 or -1. Specify 0 to obtain small compressed files, 100 for large uncompressed files, and -1 (the default) to use the default settings.
        if(!inImage.save(fileName,0,-1))
        {
            QMessageBox::warning(0,"can't save","fail!!");
        }
    }
    else
        QMessageBox::warning(0,"can't open save file","can't open save file");

}
void MainWindow::paintEvent(QPaintEvent*)
{
    if(flag==1)//ファイルが読み込まれている場合はviewを描画する
       m_view->show();
}
