#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QMainWindow>

//Guiのためのincludeファイルの追加
#include <QtGui>//menu
#include<qimage.h>//pixmap用のincludeファイル設定
#include<qpixmap.h>//image用のincludeファイル設定

#include "cdatacreate2d.h"//二次元配列を動的に確保するクラス。例：data[hsize][vsize]

//add class
class Scene;
class View;
//////////////
class QMenu;//classの宣言

namespace Ui {
class MainWindow;
}

class MainWindow : public QMainWindow
{
    Q_OBJECT
    
public:
    explicit MainWindow(QWidget *parent = 0);
    ~MainWindow();
    QImage inImage;//画像読み込み、保持用
    QPixmap pixmap_in;//デバイス依存のオフスクリーン構造体
    
    CDataCreate2D *m_dcrt2d;//CDataCreate2Dで二次元配列を確保するクラスを定義する。
private:
    Ui::MainWindow *ui;
//add menber item
    QMenu *fileMenu;//メニューバー追加用。
    QAction *newAct;//Newアイテム追加用。
    QAction *saveAsAct;//画像のセーブ用メニュー
    QGraphicsPixmapItem *gpmapI;//描画用のpixmapを保持する
    Scene *m_scene;
    View *m_view;
    int flag;//

private:
     void createMenus();//メニューバー作成用の関数追加用。自分でインプリメント
     void createActions();//Newアイテム作成用の関数追加用。自分でインプリメント
     void paintEvent(QPaintEvent*);//再描画用の関数をオーバーライドする。

public slots://slotsの実装
     void newFile();//スロット関数追加用。自分でインプリメント
     void saveAs();//saveAsを選んだときのスロット関数
};

#endif // MAINWINDOW_H
